/* Test */

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <intuition/screens.h>
#include <graphics/view.h>

struct IntuitionBase *IntuitionBase;
struct GfxBase	*GfxBase;
struct DosLibrary *DOSBase;
struct Library *Test;

UWORD colors[]={0xf62,0x777};

#define offsetof(s,m) (ULONG)&(((s*)0)->m)

LONG __saveds main(void)
{
	if (DOSBase=(struct DosLibrary *)OpenLibrary("dos.library",37L))
	{
		if (GfxBase=(struct GfxBase*)OpenLibrary("graphics.library",37L))
		{
			if (IntuitionBase=(struct IntuitionBase*)OpenLibrary("intuition.library",37L))
			{
				struct View *View=ViewAddress();
				struct ViewExtra *VE=GfxLookUp(View);
				struct Screen *Screen=LockPubScreen(NULL);
				struct ViewPort *VP=&Screen->ViewPort;
				struct ColorMap *CM=VP->ColorMap;
				
				SetRGB32(VP,0,0xffffffff,0,0);
				
				UnlockPubScreen(NULL,Screen);
				CloseLibrary((struct Library*)IntuitionBase);
			}
			CloseLibrary((struct Library*)GfxBase);
		}
		CloseLibrary((struct Library*)DOSBase);
	}
	return(0);
}
